const U = [
  "left_control",
  "left_shift",
  "left_option",
  "left_command",
  "right_control",
  "right_shift",
  "right_option",
  "right_command",
  "fn"
], ue = [
  ...U,
  "caps_lock"
], ce = [
  "return_or_enter",
  "escape",
  "delete_or_backspace",
  "delete_forward",
  "tab",
  "spacebar",
  "hyphen",
  "equal_sign",
  "open_bracket",
  "close_bracket",
  "backslash",
  "non_us_pound",
  "semicolon",
  "quote",
  "grave_accent_and_tilde",
  "comma",
  "period",
  "slash",
  "non_us_backslash"
], _e = [
  "up_arrow",
  "down_arrow",
  "left_arrow",
  "right_arrow",
  "page_up",
  "page_down",
  "home",
  "end"
], de = [
  "a",
  "b",
  "c",
  "d",
  "e",
  "f",
  "g",
  "h",
  "i",
  "j",
  "k",
  "l",
  "m",
  "n",
  "o",
  "p",
  "q",
  "r",
  "s",
  "t",
  "u",
  "v",
  "w",
  "x",
  "y",
  "z"
], fe = [
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "8",
  "9",
  "0"
], pe = [
  "f1",
  "f2",
  "f3",
  "f4",
  "f5",
  "f6",
  "f7",
  "f8",
  "f9",
  "f10",
  "f11",
  "f12",
  "f13",
  "f14",
  "f15",
  "f16",
  "f17",
  "f18",
  "f19",
  "f20"
], he = [
  "keypad_num_lock",
  "keypad_slash",
  "keypad_asterisk",
  "keypad_hyphen",
  "keypad_plus",
  "keypad_enter",
  "keypad_1",
  "keypad_2",
  "keypad_3",
  "keypad_4",
  "keypad_5",
  "keypad_6",
  "keypad_7",
  "keypad_8",
  "keypad_9",
  "keypad_0",
  "keypad_period",
  "keypad_equal_sign",
  "keypad_comma"
], me = [
  "print_screen",
  "scroll_lock",
  "pause",
  "insert",
  "application",
  "help",
  "power"
], ye = [
  "international1",
  "international3",
  "lang1",
  "lang2"
], be = ["japanese_eisuu", "japanese_kana"], ge = [
  "volume_down",
  // equal to `volume_decrement`
  "volume_up",
  // equal to `volume_increment`
  "mute",
  "volume_decrement",
  "volume_increment"
], N = [
  // Function keys
  "f21",
  "f22",
  "f23",
  "f24",
  // Keys in pc keyboards
  "execute",
  "menu",
  "select",
  "stop",
  "again",
  "undo",
  "cut",
  "copy",
  "paste",
  "find",
  // International keys
  "international2",
  "international4",
  "international5",
  "international6",
  "international7",
  "international8",
  "international9",
  "lang3",
  "lang4",
  "lang5",
  "lang6",
  "lang7",
  "lang8",
  "lang9",
  // Japanese
  "japanese_pc_nfer",
  // PCキーボードの無変換キー
  "japanese_pc_xfer",
  // PCキーボードの変換キー
  "japanese_pc_katakana",
  // PCキーボードのかなキー
  // Others
  "keypad_equal_sign_as400",
  "locking_caps_lock",
  "locking_num_lock",
  "locking_scroll_lock",
  "alternate_erase",
  "sys_req_or_attention",
  "cancel",
  "clear",
  "prior",
  "return",
  // rarely used return (HID usage 0x9e)
  "separator",
  "out",
  "oper",
  "clear_or_again",
  "cr_sel_or_props",
  "ex_sel"
], D = [
  // Disable this key
  "vk_none",
  // Others
  "vk_consumer_brightness_down",
  // equal to `display_brightness_decrement`
  "vk_consumer_brightness_up",
  // equal to `display_brightness_increment`
  "vk_mission_control",
  // equal to `mission_control`
  "vk_launchpad",
  // equal to `launchpad`
  "vk_dashboard",
  // equal to `dashboard`
  "vk_consumer_illumination_down",
  // equal to `illumination_decrement`
  "vk_consumer_illumination_up",
  // equal to `illumination_increment`
  "vk_consumer_previous",
  // equal to `rewind`
  "vk_consumer_play",
  // equal to `play`
  "vk_consumer_next",
  // equal to `fast_forward`
  "display_brightness_decrement",
  "display_brightness_increment",
  "rewind",
  "play_or_pause",
  "fastforward",
  "apple_display_brightness_decrement",
  "apple_display_brightness_increment",
  "dashboard",
  "launchpad",
  "mission_control",
  "apple_top_case_display_brightness_decrement",
  "apple_top_case_display_brightness_increment",
  "illumination_decrement",
  "illumination_increment"
], dt = [
  // Media controls
  "rewind",
  "play_or_pause",
  "fast_forward",
  "mute",
  "volume_decrement",
  "volume_increment",
  "al_terminal_lock_or_screensaver",
  // Lock key on Magic Keyboard without Touch ID
  "eject",
  "scan_previous_track",
  "scan_next_track",
  // Application Launch keys
  "al_word_processor",
  "al_text_editor",
  "al_spreadsheet",
  "al_presentation_app",
  "al_email_reader",
  "al_calculator",
  "al_local_machine_browser",
  "al_internet_browser",
  "al_dictionary",
  // Others
  "fastforward"
], ft = [
  // Media controls
  "menu",
  // Touch ID on Magic Keyboard
  // Application Launch keys
  "al_graphics_editor",
  "al_database_app",
  "al_newsreader",
  "al_voicemail",
  "al_contacts_or_address_book",
  "al_Calendar_Or_Schedule",
  "al_task_or_project_manager",
  "al_log_or_journal_or_timecard",
  "al_checkbook_or_finance",
  "al_a_or_v_capture_or_playback",
  "al_lan_or_wan_browser",
  "al_remote_networking_or_isp_connect",
  "al_network_conference",
  "al_network_chat",
  "al_telephony_or_dialer",
  "al_logon",
  "al_logoff",
  "al_logon_or_logoff",
  "al_control_panel",
  "al_command_line_processor_or_run",
  "al_process_or_task_manager",
  "al_select_task_or_application",
  "al_next_task_or_application",
  "al_previous_task_or_application",
  "al_preemptive_halt_task_or_application",
  "al_integrated_help_center",
  "al_documents",
  "al_thesaurus",
  "al_desktop",
  "al_spell_check",
  "al_grammer_check",
  "al_wireless_status",
  "al_keyboard_layout",
  "al_virus_protection",
  "al_encryption",
  "al_screen_saver",
  "al_alarms",
  "al_clock",
  "al_file_browser",
  "al_power_status",
  "al_image_browser",
  "al_audio_browser",
  "al_movie_browser",
  "al_digital_rights_manager",
  "al_digital_wallet",
  "al_instant_messaging",
  "al_oem_feature_browser",
  "al_oem_help",
  "al_online_community",
  "al_entertainment_content_browser",
  "al_online_shopping_browswer",
  "al_smart_card_information_or_help",
  "al_market_monitor_or_finance_browser",
  "al_customized_corporate_news_browser",
  "al_online_activity_browswer",
  "al_research_or_search_browswer",
  "al_audio_player",
  "al_message_status",
  "al_contact_sync",
  "al_navigation",
  "al_contextaware_desktop_assistant",
  // Generic GUI application Control keys
  "ac_home",
  "ac_back",
  "ac_forward",
  "ac_refresh",
  "ac_bookmarks",
  // Remote control buttons
  "menu_pick",
  "menu_up",
  "menu_down",
  "menu_left",
  "menu_right",
  "menu_escape",
  "menu_value_increase",
  "menu_value_decrease",
  "data_on_screen",
  "closed_caption",
  "closed_caption_select",
  "vcr_or_tv",
  "broadcast_mode",
  "snapshot",
  "still",
  "picture_in_picture_toggle",
  "picture_in_picture_swap",
  "red_menu_button",
  "green_menu_button",
  "blue_menu_button",
  "yellow_menu_button",
  "aspect",
  "three_dimensional_mode_select"
], pt = [
  // Media controls
  "display_brightness_decrement",
  "display_brightness_increment",
  "dictation"
], ht = [
  "button1",
  "button2",
  "button3",
  "button4",
  "button5",
  "button6",
  "button7",
  "button8",
  "button9",
  "button10",
  "button11",
  "button12",
  "button13",
  "button14",
  "button15",
  "button16",
  "button17",
  "button18",
  "button19",
  "button20",
  "button21",
  "button22",
  "button23",
  "button24",
  "button25",
  "button26",
  "button27",
  "button28",
  "button29",
  "button30",
  "button31",
  "button32"
], P = {
  "⌘": "command",
  "⌥": "option",
  "⌃": "control",
  "⇧": "shift",
  "⇪": "caps_lock"
}, ie = {
  "↑": "up_arrow",
  "↓": "down_arrow",
  "←": "left_arrow",
  "→": "right_arrow",
  "⇞": "page_up",
  "⇟": "page_down",
  "↖︎": "home",
  "↘︎": "end"
}, oe = {
  "⏎": "return_or_enter",
  "⎋": "escape",
  "⌫": "delete_or_backspace",
  "⌦": "delete_forward",
  "⇥": "tab",
  "␣": "spacebar",
  "-": "hyphen",
  "=": "equal_sign",
  "[": "open_bracket",
  "]": "close_bracket",
  "\\": "backslash",
  ";": "semicolon",
  "'": "quote",
  "`": "grave_accent_and_tilde",
  ",": "comma",
  ".": "period",
  "/": "slash"
}, G = {
  ...ie,
  ...oe,
  "⇪": P["⇪"]
}, ke = [
  ...U,
  ...ue,
  ...ce,
  ..._e,
  ...de,
  ...fe,
  ...pe,
  ...he,
  ...me,
  ...ye,
  ...be,
  ...ge,
  ...N,
  ...D
];
function C(t, e, i) {
  if (typeof t == "number")
    return `${t}`;
  if (t.length > 1 && q(t)) {
    const n = J(t);
    if ((n == null ? void 0 : n.length) === 1)
      return n[0];
    throw new Error(`Invalid key ${t}`);
  }
  if (t in G)
    return G[t];
  const o = t;
  if (!ke.includes(o))
    throw new Error(`${o} is not valid key_code`);
  if (e != null && e.includes(o))
    throw new Error(`Key ${t} cannot be used ${i || "here"}`);
  return o;
}
const we = {
  Meh: ["option", "control", "shift"],
  Hyper: ["command", "option", "control", "shift"],
  SuperHyper: ["command", "option", "control", "shift", "fn"]
}, Q = {
  "⌘⇧": ["command", "shift"],
  "⌥⇧": ["option", "shift"],
  "⌃⇧": ["control", "shift"],
  "⌘⌥": ["command", "option"],
  "⌘⌃": ["command", "control"],
  "⌥⌃": ["option", "control"],
  "⌘⌥⌃": ["command", "option", "control"],
  "⌘⌥⇧": ["command", "option", "shift"],
  "⌘⌃⇧": ["command", "control", "shift"],
  "⌥⌃⇧": ["option", "control", "shift"],
  "⌘⌥⌃⇧": ["command", "option", "control", "shift"],
  ...we
};
function M(t) {
  if (!t)
    return;
  if (typeof t == "string")
    return q(t) ? J(t) : t in P ? [P[t]] : t in Q ? Q[t] : [t];
  if (Array.isArray(t))
    return Ce(t) ? Me(t) : t.map(Ae);
  let e;
  "left" in t ? e = K("left", t.left) : "l" in t && (e = K("left", t.l));
  let i;
  if ("right" in t ? i = K("right", t.right) : "r" in t && (i = K("right", t.r)), !(!(e != null && e.length) && !(i != null && i.length)))
    return [...e || [], ...i || []];
}
const ne = /^(left|l|<|‹)([⌘⌥⌃⇧]*)$/, re = /^(right|r|>|›)([⌘⌥⌃⇧]*)$/;
function j(t, e) {
  if (!(!t && !e))
    return {
      mandatory: X(t),
      optional: X(e)
    };
}
function X(t) {
  if (t)
    return t === "any" ? ["any"] : M(t);
}
const ve = /* @__PURE__ */ new Set([
  "command",
  "option",
  "control",
  "shift"
]);
function q(t) {
  return ne.test(t) || re.test(t);
}
function J(t) {
  const e = t.match(ne);
  if (e)
    return K("left", e[2]);
  const i = t.match(re);
  if (i)
    return K("right", i[2]);
}
function Ce(t) {
  return t.some(q);
}
function Me(t) {
  return t.reduce(
    (e, i) => [
      ...e,
      ...q(i) ? J(i) || [] : M(i) || []
    ],
    []
  );
}
function K(t, e) {
  var i;
  if (e)
    return (i = M(e)) == null ? void 0 : i.map(
      (o) => ve.has(o) ? `${t}_${o}` : o
    );
}
function Ae(t) {
  return t in P ? P[t] : t;
}
function p(t, e, i) {
  const o = C(
    t,
    N,
    "as to.key_code"
  );
  return {
    ...i,
    key_code: o,
    modifiers: e ? M(e) : void 0
  };
}
function Ee(t) {
  return p("left_command", "⌥⌃⇧", t);
}
function Ke(t) {
  return p("left_option", "⌃⇧", t);
}
function Se(t) {
  return p("fn", "⌘⌥⌃⇧", t);
}
function Te(t) {
  return p("vk_none", void 0, t);
}
function $e(t, e, i) {
  return {
    ...i,
    consumer_key_code: t,
    modifiers: e ? M(e) : void 0
  };
}
function je(t, e, i) {
  return {
    ...i,
    pointing_button: t,
    modifiers: e ? M(e) : void 0
  };
}
function R(t) {
  return { shell_command: t };
}
function Pe(t) {
  const e = t.match(/^"?(.*?)(.app)?"?$/);
  return R(`open -a "${(e == null ? void 0 : e[1]) || t}".app`);
}
function Oe(t) {
  return R(`osascript -e '
set prev to the clipboard
set the clipboard to "${t}"
tell application "System Events"
  keystroke "v" using command down
  delay 0.1
end tell
set the clipboard to prev'`);
}
const De = [
  "Tink",
  "Submarine",
  "Sosumi",
  "Morse",
  "Ping",
  "Pop",
  "Purr",
  "Glass",
  "Hero",
  "Frog",
  "Funk",
  "Blow",
  "Bottle",
  "Basso"
];
function mt(t) {
  const e = De.includes(t) ? `/System/Library/Sounds/${t}.aiff` : t;
  return R(`afplay ${e}`);
}
function Ve(t) {
  return { select_input_source: t };
}
function h(t, e = 1) {
  return { set_variable: { name: t, value: e } };
}
function se(t, e) {
  return { set_notification_message: { id: t, text: e } };
}
function ae(t) {
  return { set_notification_message: { id: t, text: "" } };
}
function Le(t) {
  return { mouse_key: t };
}
function Be(t, e = "toggle") {
  return { sticky_modifier: { [t]: e } };
}
function Ne(t) {
  return {
    software_function: { cg_event_double_click: { button: t } }
  };
}
function qe(t) {
  return { software_function: { set_mouse_cursor_position: t } };
}
function Re(t) {
  return {
    software_function: {
      iokit_power_management_sleep_system: { delay_milliseconds: t }
    }
  };
}
function y(t) {
  return Array.isArray(t) ? t : [t];
}
function O(t, e = 1, i) {
  return new b({ type: "variable_if", name: t, value: e, description: i });
}
function yt(t, e) {
  let i;
  if (Array.isArray(t))
    i = t.map(x);
  else if (typeof t == "string" || t instanceof RegExp)
    i = [x(t)];
  else
    return new b({
      type: "frontmost_application_if",
      description: e,
      file_paths: t.file_paths.map(x)
    });
  return new b({
    type: "frontmost_application_if",
    description: e,
    bundle_identifiers: i
  });
}
function bt(t, e) {
  return new b({
    type: "device_if",
    identifiers: y(t),
    description: e
  });
}
function gt(t, e) {
  return new b({
    type: "device_exists_if",
    identifiers: y(t),
    description: e
  });
}
function kt(t, e) {
  return new b({
    type: "keyboard_type_if",
    keyboard_types: y(t),
    description: e
  });
}
function wt(t, e) {
  return new b({
    type: "input_source_if",
    input_sources: y(t),
    description: e
  });
}
function vt(t = !0, e) {
  return new b({ type: "event_changed_if", value: t, description: e });
}
const Ie = Fe({
  frontmost_application_if: "frontmost_application_unless",
  device_if: "device_unless",
  device_exists_if: "device_exists_unless",
  keyboard_type_if: "keyboard_type_unless",
  input_source_if: "input_source_unless",
  variable_if: "variable_unless",
  event_changed_if: "event_changed_unless"
});
class b {
  constructor(e) {
    this.condition = e;
  }
  /** Switch type {condition}_if to {condition}_unless, and vice versa */
  unless() {
    return new b({
      ...this.condition,
      type: Ie[this.condition.type]
    });
  }
  build() {
    return { ...this.condition };
  }
}
function xe(t) {
  return typeof t.build == "function";
}
function A(t) {
  return xe(t) ? t.build() : t;
}
function x(t) {
  return typeof t == "string" ? t : t.toString().slice(1, -1);
}
function Fe(t) {
  return Object.keys(t).reduce((e, i) => ({ ...e, [e[i]]: i }), t);
}
const S = {};
for (let t = 0; t <= 9; t++)
  S[t] = p(t);
const He = "abcdefghijklmnopqrstuvwxyz".split("");
for (const t of He)
  S[t] = p(t), S[t.toUpperCase()] = p(t, "⇧");
const Ue = [
  ...Object.keys(ie),
  ...Object.keys(oe)
];
for (const t of Ue)
  S[t] = p(t);
const Je = {
  1: "!",
  2: "@",
  3: "#",
  4: "$",
  5: "%",
  6: "^",
  7: "&",
  8: "*",
  9: "(",
  0: ")",
  "'": '"',
  "=": "+",
  ";": ":",
  ",": "<",
  ".": ">",
  "/": "?",
  "-": "_",
  "[": "{",
  "\\": "|",
  "]": "}",
  "`": "~"
};
for (const [t, e] of Object.entries(Je))
  S[e] = p(t, "⇧");
function We(t, e) {
  return t.split("").map((i) => {
    const o = (e == null ? void 0 : e[i]) || S[i];
    if (!o)
      throw new Error(
        `${i} is unknown. Please provide a map with { ${i}: {ToEvent} }`
      );
    return o;
  });
}
const ze = ["optionalAny", "?any", "??"];
function Ge(t) {
  return !t || typeof t != "string" ? !1 : ze.includes(t);
}
function Qe(t) {
  return /^\?(left|l|<|‹|right|r|>|›)?([⌘⌥⌃⇧⇪]*)$/.test(t);
}
function m(t, e) {
  if (!t)
    return j(t, e);
  if (Ge(t))
    return j("", "any");
  if (typeof t == "string") {
    if (Qe(t))
      return j(
        "",
        M(t.slice(1))
      );
    if (t.startsWith("?"))
      throw new Error(`${t} is not valid optional alias`);
  }
  return typeof t == "object" && "optional" in t ? j("", t.optional) : j(t, e);
}
function W(t, e, i) {
  if (typeof t == "object")
    return new T(t);
  const o = C(
    t,
    D,
    "for from.key_code"
  );
  return new T({
    key_code: o,
    modifiers: m(e, i)
  });
}
function Ct(t, e, i) {
  return new T({
    consumer_key_code: t,
    modifiers: m(e, i)
  });
}
function Mt(t, e, i) {
  return new T({
    pointing_button: t,
    modifiers: m(e, i)
  });
}
class T {
  constructor(e) {
    this.manipulator = { type: "basic", from: e };
  }
  /** The FromEvent of the Manipulator. */
  get from() {
    return this.manipulator.from;
  }
  to(e, i, o) {
    return this.addToEvent(
      typeof e == "object" ? e : p(e, i, o)
    ), this;
  }
  /** To Hyper key ⌘⌥⌃⇧ */
  toHyper(e) {
    return this.addToEvent(Ee(e)), this;
  }
  /** To Meh key ⌥⌃⇧ */
  toMeh(e) {
    return this.addToEvent(Ke(e)), this;
  }
  /** To SuperHyper key ⌘⌥⌃⇧fn */
  toSuperHyper(e) {
    return this.addToEvent(Se(e)), this;
  }
  /** To vk_none (Disable this key) */
  toNone(e) {
    return this.addToEvent(Te(e)), this;
  }
  /** To { consumer_key_code } */
  toConsumerKey(e, i, o) {
    return this.addToEvent($e(e, i, o)), this;
  }
  /** Map to mouse button */
  toPointingButton(e, i, o) {
    return this.addToEvent(je(e, i, o)), this;
  }
  /** Map to shell command */
  to$(e) {
    return this.addToEvent(R(e)), this;
  }
  /** Map to `$ open -a {app}.app` */
  toApp(e) {
    return this.addToEvent(Pe(e)), this;
  }
  /** Map to paste {text} via clipboard */
  toPaste(e) {
    return this.addToEvent(Oe(e)), this;
  }
  /** To change the current input source */
  toInputSource(e) {
    return this.addToEvent(Ve(e)), this;
  }
  /** Map to setting a variable */
  toVar(e, i = 1) {
    return this.addToEvent(h(e, i)), this;
  }
  /** To set or remove (set text to '') the notification message */
  toNotificationMessage(e, i) {
    return this.addToEvent(se(e, i)), this;
  }
  /** To remove the notification message */
  toRemoveNotificationMessage(e) {
    return this.addToEvent(ae(e)), this;
  }
  /** Move mouse cursor by delta */
  toMouseKey(e) {
    return this.addToEvent(Le(e)), this;
  }
  /** Changes to a sticky modifier key */
  toStickyModifier(e, i = "toggle") {
    return this.addToEvent(Be(e, i)), this;
  }
  /** @see https://karabiner-elements.pqrs.org/docs/json/complex-modifications-manipulator-definition/to/software_function/cg_event_double_click/ */
  toCgEventDoubleClick(e) {
    return this.addToEvent(Ne(e)), this;
  }
  /** Set mouse cursor position */
  toMouseCursorPosition(e) {
    return this.addToEvent(qe(e)), this;
  }
  /** To causes a system sleep */
  toSleepSystem(e) {
    return this.addToEvent(Re(e)), this;
  }
  /** To type a string of keys */
  toTypeSequence(e, i) {
    return this.addToEvent(We(e, i)), this;
  }
  toIfAlone(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_if_alone",
      typeof e == "object" ? e : p(e, i, o)
    ), this;
  }
  toIfHeldDown(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_if_held_down",
      typeof e == "object" ? e : p(e, i, o)
    ), this;
  }
  toAfterKeyUp(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_after_key_up",
      typeof e == "object" ? e : p(e, i, o)
    ), this;
  }
  toDelayedAction(e, i) {
    const o = this.manipulator.to_delayed_action || {
      to_if_invoked: [],
      to_if_canceled: []
    };
    return y(e).forEach((n) => o.to_if_invoked.push(n)), y(i).forEach((n) => o.to_if_canceled.push(n)), this.manipulator.to_delayed_action = o, this;
  }
  description(e) {
    return this.manipulator.description = e, this;
  }
  condition(...e) {
    const { conditions: i = [] } = this.manipulator;
    return this.manipulator.conditions = [...i, ...e.map(A)], this;
  }
  parameters(e) {
    return this.manipulator.parameters = { ...this.manipulator.parameters, ...e }, this;
  }
  build(e) {
    return [{ ...this.manipulator }];
  }
  addToEvent(e) {
    this.pushOrCreateList(this.manipulator, "to", e);
  }
  pushOrCreateList(e, i, o) {
    const n = e[i] || [];
    y(o).forEach((r) => n.push(r)), Object.assign(e, { [i]: n });
  }
}
function Xe(t) {
  return typeof t.build == "function";
}
function $(t, e) {
  return Xe(t) ? t.build(e) : "type" in t ? [t] : Object.entries(t).reduce(
    (o, [n, r]) => [...o, ...W(n).to(r).build(e)],
    []
  );
}
function At(...t) {
  return (e) => {
    const i = t.map(A);
    function o(s) {
      return s.type !== "basic" ? s : {
        ...s,
        conditions: [...s.conditions || [], ...i]
      };
    }
    const r = (Array.isArray(e) ? e : $(e)).reduce(
      (s, l) => [...s, ...$(l).map(o)],
      []
    );
    return Object.assign(r, { build: () => r });
  };
}
function Et(t) {
  return (e) => ({
    build: () => (Array.isArray(t) ? t.map((o, n) => [o, n]) : Object.entries(t)).reduce(
      (o, [n, r]) => [...o, ...$(e(n, r))],
      []
    )
  });
}
function Kt(t, e) {
  return (i) => ({
    build: (o) => {
      const n = m(
        t,
        e
      );
      return (Array.isArray(i) ? i : $(i)).map((s) => $(s, o)).reduce((s, l) => s.concat(l), []).map((s) => {
        var a;
        const l = Object.keys(n).reduce(
          (u, c) => {
            var _;
            if (!((_ = n[c]) != null && _.length))
              return u;
            const f = /* @__PURE__ */ new Set([
              ...u[c] || [],
              ...n[c]
            ]);
            return u[c] = f.has("any") ? ["any"] : Array.from(f), u;
          },
          { ...(a = s.from) == null ? void 0 : a.modifiers }
        );
        return s.from = { ...s.from, modifiers: l }, s;
      });
    }
  });
}
function Ye(t, e, i) {
  const o = (r) => C(r, D, "for from.simultaneous"), n = new Ze({
    simultaneous: t.map(
      (r) => typeof r == "object" ? r : { key_code: o(r) }
    ),
    simultaneous_options: e
  });
  return i && n.parameters({
    "basic.simultaneous_threshold_milliseconds": i
  }), n;
}
class Ze extends T {
  constructor(e) {
    super(e);
  }
  modifiers(e, i) {
    return this.manipulator.from.modifiers = e || i ? m(e, i) : void 0, this;
  }
}
const Y = {
  "double_tap.delay_milliseconds": 200
};
function St(t, e, i, o) {
  const n = C(
    t,
    [...N, ...D],
    "for double tap"
  ), r = new et({ key_code: n });
  return o ? (r.delay(o), r.from.modifiers = m(
    e,
    i
  )) : i ? typeof i == "number" ? (r.delay(i), r.from.modifiers = m(
    e
  )) : r.from.modifiers = m(
    e,
    i
  ) : e && (typeof e == "number" ? r.delay(e) : r.from.modifiers = m(
    e
  )), r;
}
class et extends T {
  constructor(e) {
    super(e), this.singleTapEvent = void 0;
  }
  /** Set single tap which is from key by default; null to disable */
  singleTap(e) {
    return this.singleTapEvent = e, this;
  }
  /** Set the delay parameter */
  delay(e) {
    return this.delayParam = e, this;
  }
  build(e) {
    var f;
    const i = (e == null ? void 0 : e.getParameters(Y)) ?? Y, o = this.delayParam || i["double_tap.delay_milliseconds"], n = this.from.key_code;
    if (this.singleTapEvent === void 0) {
      this.singleTapEvent = { key_code: n };
      const _ = (f = this.manipulator.from.modifiers) == null ? void 0 : f.mandatory;
      _ && (this.singleTapEvent.modifiers = _.filter(
        (v) => v !== "any"
      ));
    }
    const r = ["double-tap", n];
    this.from.modifiers && [this.from.modifiers.mandatory, this.from.modifiers.optional].map((_) => _ != null && _.length ? _.join(",") : "").forEach((_) => _ && r.push(_));
    const s = r.join("-"), l = O(s).build(), a = O(s).unless().build(), u = {
      ...this.manipulator,
      conditions: [...this.manipulator.conditions || [], l]
    }, c = {
      ...this.manipulator,
      to: [h(s, 1)],
      conditions: [a],
      to_delayed_action: {
        to_if_invoked: [
          ...this.singleTapEvent ? [this.singleTapEvent] : [],
          h(s, 0)
        ],
        to_if_canceled: [h(s, 0)]
      }
    };
    return c.parameters = {
      "basic.to_delayed_action_delay_milliseconds": o
    }, [u, c];
  }
}
function Tt() {
  return new tt();
}
class tt {
  constructor() {
    this.manipulator = {
      type: "mouse_motion_to_scroll"
    };
  }
  modifiers(e, i) {
    return this.manipulator.from = {
      modifiers: m(
        e,
        i
      )
    }, this;
  }
  condition(...e) {
    const { conditions: i = [] } = this.manipulator;
    return this.manipulator.conditions = [...i, ...e.map(A)], this;
  }
  options(e) {
    return this.manipulator.options = { ...this.manipulator.options, ...e }, this;
  }
  build(e) {
    return [{ ...this.manipulator }];
  }
}
function $t(t, ...e) {
  return new I(t, ...e);
}
class I {
  constructor(e, ...i) {
    this.ruleDescription = e, this.manipulatorSources = [], this.allowEmptyManipulators = !1, this.conditions = i;
  }
  manipulators(e) {
    return Array.isArray(e) ? e.forEach((i) => this.manipulatorSources.push(i)) : this.manipulatorSources.push(e), this;
  }
  condition(...e) {
    return e.forEach((i) => this.conditions.push(i)), this;
  }
  description(e) {
    return this.ruleDescription = e, this;
  }
  build(e) {
    const i = {
      description: this.ruleDescription,
      manipulators: this.manipulatorSources.reduce(
        (n, r) => [...n, ...$(r, e)],
        []
      )
    };
    if (!this.allowEmptyManipulators && i.manipulators.length === 0)
      throw new Error(`"manipulators" is empty in "${i.description}"`);
    if (this.conditions.length === 0)
      return i;
    const o = this.conditions.map(A);
    return i.manipulators = i.manipulators.map(
      (n) => n.type === "basic" ? { ...n, conditions: [...n.conditions || [], ...o] } : { ...n }
    ), i;
  }
}
function it(t) {
  return typeof t.build == "function";
}
function ot(t, e) {
  return it(t) ? t.build(e) : t;
}
const H = [
  ...D,
  ...N,
  ...U
];
function nt(t, e, i = 1, o = 0) {
  return new st(t, e, i, o);
}
function rt(t, e, i, o = 1, n = 0) {
  return nt(e, i, o, n).modifiers(t);
}
function jt(t, e, i = 1, o = 0) {
  return rt("Hyper", t, e, i, o);
}
class st extends I {
  constructor(e, i, o = 1, n = 0) {
    const r = y(e).map(
      (s) => C(s, H, "as layer key")
    );
    i || (i = `layer-${r.join("-")}`), super(`Layer - ${i}`), this.onValue = o, this.offValue = n, this.replaceLayerKeyToIfAlone = !1, this.keys = r, this.varName = i, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition), this.allowEmptyManipulators = !0;
  }
  modifiers(e, i) {
    return this.layerModifiers = e || i ? m(e, i) : void 0, this;
  }
  /** Config the layer key. */
  configKey(e, i = !1) {
    return this.layerKeyManipulator || (this.layerKeyManipulator = W("fn")), e(this.layerKeyManipulator), this.replaceLayerKeyToIfAlone = i, this;
  }
  build(e) {
    var n, r, s, l;
    const i = super.build(e), o = this.conditions.filter((a) => a !== this.layerCondition).map(A);
    if ((r = (n = this.layerModifiers) == null ? void 0 : n.mandatory) != null && r.length || (l = (s = this.layerModifiers) == null ? void 0 : s.optional) != null && l.length) {
      const a = Z(this.layerModifiers) === "optional";
      i.manipulators.forEach(
        (u) => this.addModifierAnyToManipulator(u, a)
      );
    }
    for (const a of this.keys)
      i.manipulators = [
        ...le(
          a,
          this.varName,
          this.onValue,
          this.offValue,
          this.layerModifiers,
          o,
          e,
          this.layerKeyManipulator,
          this.replaceLayerKeyToIfAlone
        ),
        ...i.manipulators
      ];
    return i;
  }
  // If the layer has modifiers, set manipulator modifiers to { mandatory: ['any'] }
  addModifierAnyToManipulator(e, i) {
    if (e.type === "basic") {
      if (e.from.modifiers) {
        const { mandatory: o, optional: n } = e.from.modifiers;
        if (n != null && n.length || o != null && o.length) {
          const r = Z(e.from.modifiers);
          if (r === "mandatory")
            e.from.modifiers = { mandatory: ["any"] };
          else if (r === "optional")
            e.from.modifiers = { optional: ["any"] };
          else
            throw new Error(
              "Layers with modifiers cannot have modifiers on manipulators"
            );
          return;
        }
      }
      e.from.modifiers = i ? { optional: ["any"] } : { mandatory: ["any"] };
    }
  }
}
function le(t, e, i, o, n, r, s, l, a) {
  function u(g) {
    var z;
    if (!l)
      return g;
    const k = l.build()[0], d = y(g)[0];
    if ([
      "to",
      "to_if_alone",
      "to_if_held_down",
      "to_after_key_up"
    ].forEach(
      (w) => {
        var V;
        return (V = k[w]) == null ? void 0 : V.forEach(
          (L) => d[w] = [...d[w] || [], L]
        );
      }
    ), k.to_delayed_action) {
      d.to_delayed_action = d.to_delayed_action || {
        to_if_invoked: [],
        to_if_canceled: []
      };
      for (const w of ["to_if_invoked", "to_if_canceled"])
        k.to_delayed_action[w].forEach(
          (V) => {
            var L;
            return (L = d.to_delayed_action) == null ? void 0 : L[w].push(V);
          }
        );
    }
    return a && (d.to_if_alone = (z = d.to_if_alone) == null ? void 0 : z.filter(
      (w) => !("key_code" in w && w.key_code === t)
    )), g;
  }
  const c = W({ key_code: t, modifiers: n }).toVar(e, i).toAfterKeyUp(h(e, o)).toIfAlone({ key_code: t });
  if (r != null && r.length && c.condition(...r), !s)
    return u(c.build());
  const f = [
    `layer_${t}`,
    ...n ? [JSON.stringify(n)] : [],
    ...(r || []).map((g) => JSON.stringify(g)).sort()
  ].join("_"), _ = s.getCache(f);
  if (_ != null && _.to && _.to_after_key_up)
    return _.to.find(
      (k) => "set_variable" in k && k.set_variable.name === e
    ) || (_.to.push(h(e, i)), _.to_after_key_up.push(h(e, o))), u(_), [];
  const v = c.build(s);
  return s.setCache(f, v[0]), u(v);
}
function Z({
  mandatory: t,
  optional: e
}) {
  return (t == null ? void 0 : t.length) === 1 && t[0] === "any" ? "mandatory" : (e == null ? void 0 : e.length) === 1 && e[0] === "any" ? "optional" : null;
}
const ee = {
  "simlayer.threshold_milliseconds": 200
};
function Pt(t, e, i, o = 1, n = 0) {
  return new at(t, e, i, o, n);
}
class at extends I {
  constructor(e, i, o, n = 1, r = 0) {
    const s = y(e).map(
      (l) => C(l, H, "as simlayer key")
    );
    i || (i = `simlayer-${s.join("-")}`), super(`Simlayer - ${i}`), this.threshold = o, this.onValue = n, this.offValue = r, this.sharedLayerKeys = [], this.simultaneousOptions = {
      detect_key_down_uninterruptedly: !0,
      key_down_order: "strict",
      key_up_order: "strict_inverse",
      key_up_when: "any"
    }, this.layerModifiers = { optional: ["any"] }, this.keys = s, this.varName = i, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition);
  }
  modifiers(e, i) {
    return this.layerModifiers = e || i ? m(e, i) : void 0, this;
  }
  /** Set simultaneous_options on the simlayer toggle manipulator */
  options(e) {
    return Object.assign(this.simultaneousOptions, e), this;
  }
  /** Enable layer with the same variable and manipulators with this simlayer */
  enableLayer(...e) {
    return e.map(
      (i) => C(i, H, "as layer key")
    ).forEach((i) => {
      if (this.keys.includes(i))
        throw new Error(`Key ${i} is already used in ${this.ruleDescription}`);
      if (this.sharedLayerKeys.includes(i))
        throw new Error(
          `Key ${i} is already used as shared layer key in  ${this.ruleDescription}`
        );
      this.sharedLayerKeys.push(i);
    }), this;
  }
  build(e) {
    const i = super.build(e), o = (e == null ? void 0 : e.getParameters(ee)) ?? ee, n = this.threshold || o["simlayer.threshold_milliseconds"], r = this.conditions.length > 1 ? this.conditions.filter((a) => a !== this.layerCondition).map(A) : void 0, s = h(this.varName, this.onValue), l = h(this.varName, this.offValue);
    i.manipulators.concat().forEach((a) => {
      var c;
      if (a.type !== "basic")
        throw new Error(
          `Unsupported manipulator type ${a.type} in simlayer ${this.ruleDescription}`
        );
      const u = (c = a.from) == null ? void 0 : c.key_code;
      if (!u)
        throw new Error(
          `Missing from.key_code in simlayer ${this.ruleDescription}`
        );
      this.layerModifiers && (a.from.modifiers = {
        ...a.from.modifiers,
        ...this.layerModifiers
      });
      for (const f of this.keys)
        i.manipulators.push({
          type: "basic",
          parameters: {
            "basic.simultaneous_threshold_milliseconds": n
          },
          to: [s, ...a.to || []],
          from: {
            simultaneous: [{ key_code: f }, { key_code: u }],
            simultaneous_options: {
              ...this.simultaneousOptions,
              to_after_key_up: [
                ...this.simultaneousOptions.to_after_key_up || [],
                l
              ]
            },
            modifiers: this.layerModifiers
          },
          conditions: r
        });
    });
    for (const a of this.sharedLayerKeys)
      i.manipulators = [
        ...le(
          a,
          this.varName,
          this.onValue,
          this.offValue,
          this.layerModifiers,
          r,
          e
        ),
        ...i.manipulators
      ];
    return i;
  }
}
const te = {
  "duo_layer.threshold_milliseconds": 200,
  "duo_layer.notification": !1
};
function Ot(t, e, i, o = 1, n = 0) {
  return new lt(t, e, i, o, n);
}
class lt extends I {
  constructor(e, i, o, n = 1, r = 0) {
    const s = `DuoLayer ${o || `${e} ${i}`}`;
    o || (o = `duo-layer-${e}-${i}`), super(s), this.key1 = e, this.key2 = i, this.onValue = n, this.offValue = r, this.simultaneousOptions = {}, this.ifActivated = [], this.ifDeactivated = [], this.varName = o, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition), this.allowEmptyManipulators = !0;
  }
  threshold(e) {
    return this.simultaneousThreshold = e, this;
  }
  options(e) {
    return Object.assign(this.simultaneousOptions, e), this;
  }
  /** Set the notification when the layer is active. */
  notification(e) {
    return this.layerNotification = e, this;
  }
  /** The ToEvents to trigger when the layer is activated */
  toIfActivated(e) {
    return this.ifActivated.push(e), this;
  }
  /** The ToEvents to trigger when the layer is deactivated */
  toIfDeactivated(e) {
    return this.ifDeactivated.push(e), this;
  }
  build(e) {
    var _, v, g, k;
    const i = super.build(e), o = (e == null ? void 0 : e.getParameters(te)) ?? te, n = this.simultaneousThreshold || o["duo_layer.threshold_milliseconds"], r = this.layerNotification ?? o["duo_layer.notification"], s = this.conditions.filter((d) => d !== this.layerCondition).map(A), l = [h(this.varName, this.onValue), ...this.ifActivated], a = [
      h(this.varName, this.offValue),
      ...this.simultaneousOptions.to_after_key_up || [],
      ...this.ifDeactivated
    ];
    if (r) {
      const d = `duo-layer-${this.varName}`, E = r === !0 ? this.ruleDescription : r;
      l.push(se(d, E)), a.push(ae(d));
    }
    const u = Ye(
      [this.key1, this.key2],
      {
        ...this.simultaneousOptions,
        to_after_key_up: a
      },
      n
    ).modifiers("??").to(l);
    if (s.length && u.condition(...s), !e)
      return i.manipulators = [...u.build(), ...i.manipulators], i;
    const c = [
      `duo_layer_${this.key1}_${this.key2}`,
      ...s.map((d) => JSON.stringify(d)).sort()
    ].join("_"), f = e.getCache(c);
    if (f)
      ((_ = f.to) == null ? void 0 : _.find(
        (E) => "set_variable" in E && E.set_variable.name === this.varName
      )) || ((v = f.to) == null || v.push(h(this.varName, this.onValue)), (k = (g = f.from.simultaneous_options) == null ? void 0 : g.to_after_key_up) == null || k.push(
        h(this.varName, this.offValue)
      ));
    else {
      const d = u.build(e)[0];
      e.setCache(c, d), i.manipulators = [d, ...i.manipulators];
    }
    return i;
  }
}
class ut {
  constructor() {
    this.parameters = {}, this.cache = /* @__PURE__ */ new Map();
  }
  setParameters(e) {
    Object.assign(this.parameters, e);
  }
  getParameters(e) {
    const i = { ...e };
    for (const o of Object.keys(e))
      o in this.parameters && this.parameters[o] !== void 0 && Object.assign(i, { [o]: this.parameters[o] });
    return i;
  }
  getCache(e) {
    return this.cache.get(e);
  }
  setCache(e, i) {
    this.cache.set(e, i);
  }
}
const ct = {
  "basic.to_if_alone_timeout_milliseconds": 1e3,
  "basic.to_if_held_down_threshold_milliseconds": 500,
  "basic.to_delayed_action_delay_milliseconds": 500,
  "basic.simultaneous_threshold_milliseconds": 50,
  "mouse_motion_to_scroll.speed": 100
};
function _t(t, e = {}) {
  const {
    "double_tap.delay_milliseconds": i,
    "simlayer.threshold_milliseconds": o,
    "duo_layer.threshold_milliseconds": n,
    "duo_layer.notification": r,
    ...s
  } = e, l = new ut();
  l.setParameters({
    "double_tap.delay_milliseconds": i
  }), l.setParameters({
    "simlayer.threshold_milliseconds": o
  }), l.setParameters({
    "duo_layer.threshold_milliseconds": n,
    "duo_layer.notification": r
  });
  const a = t.map((c) => ot(c, l)), u = {
    rules: a.filter((c) => c.manipulators.length),
    parameters: {
      ...ct,
      ...s
    }
  };
  if (u.rules.length === 0)
    throw new Error('complex_modifications "rules" is empty ');
  return u.rules.length < a.length && console.warn(`Rules with empty manipulators are ignored: 
${a.filter((c) => c.manipulators.length === 0).map((c) => "- " + c.description).join(`
`)}
`), u;
}
const B = {
  karabinerConfigDir() {
    return require("node:path").join(
      require("node:os").homedir(),
      ".config/karabiner"
    );
  },
  karabinerConfigFile() {
    return require("node:path").join(
      this.karabinerConfigDir(),
      "karabiner.json"
    );
  },
  readKarabinerConfig(t) {
    return require(t ?? this.karabinerConfigFile());
  },
  writeKarabinerConfig(t, e) {
    return require("node:fs/promises").writeFile(
      e ?? this.karabinerConfigFile(),
      t
    );
  },
  exit(t = 0) {
    process.exit(t);
  }
};
function Dt(t, e, i = {}) {
  typeof t == "string" && (t = { name: t, dryRun: t === "--dry-run" });
  const { name: o, dryRun: n } = t, r = t.karabinerJsonPath ?? B.karabinerConfigFile(), s = n ? { profiles: [{ name: o, complex_modifications: { rules: [] } }] } : B.readKarabinerConfig(r), l = s == null ? void 0 : s.profiles.find((u) => u.name === o);
  l || F(`⚠️ Profile ${o} not found in ${r}.

ℹ️ Please check the profile name in the Karabiner-Elements UI and 
    - Update the profile name at writeToProfile()
    - Create a new profile if needed
 `);
  try {
    l.complex_modifications = _t(e, i);
  } catch (u) {
    F(u);
  }
  const a = JSON.stringify(s, null, 2);
  if (n) {
    console.info(a);
    return;
  }
  B.writeKarabinerConfig(a, r).catch(F), console.log(`✓ Profile ${o} updated.`);
}
function F(t) {
  return t && console.error(typeof t == "string" ? t : t.message || t), B.exit(1);
}
export {
  b as ConditionBuilder,
  ie as arrowKeyAliases,
  _e as arrowKeyCodes,
  A as buildCondition,
  _t as complexModifications,
  oe as controlOrSymbolKeyAliases,
  ce as controlOrSymbolKeyCodes,
  ct as defaultComplexModificationsParameters,
  Y as defaultDoubleTapParameters,
  te as defaultDuoLayerParameters,
  ee as defaultSimlayerParameters,
  Ot as duoLayer,
  dt as fromAndToConsumerKeyCodes,
  ft as fromOnlyConsumerKeyCodes,
  N as fromOnlyKeyCodes,
  pe as functionKeyCodes,
  C as getKeyWithAlias,
  jt as hyperLayer,
  yt as ifApp,
  bt as ifDevice,
  gt as ifDeviceExists,
  vt as ifEventChanged,
  wt as ifInputSource,
  kt as ifKeyboardType,
  O as ifVar,
  ye as internationalKeyCodes,
  xe as isConditionBuilder,
  q as isSideMultiModifierAlias,
  be as japaneseKeyCodes,
  he as keypadKeyCodes,
  nt as layer,
  de as letterKeyCodes,
  W as map,
  Ct as mapConsumerKey,
  St as mapDoubleTap,
  Mt as mapPointingButton,
  Ye as mapSimultaneous,
  P as modifierKeyAliases,
  ue as modifierKeyCodes,
  rt as modifierLayer,
  Tt as mouseMotionToScroll,
  Q as multiModifierAliases,
  we as namedMultiModifierAliases,
  fe as numberKeyCodes,
  ge as otherKeyCodes,
  j as parseFromModifierParams,
  M as parseModifierParam,
  J as parseSideMultiModifierAlias,
  me as pcKeyboardKeyCodes,
  ht as pointingButtons,
  $t as rule,
  Pt as simlayer,
  U as stickyModifierKeyCodes,
  De as systemSounds,
  R as to$,
  Pe as toApp,
  Ne as toCgEventDoubleClick,
  $e as toConsumerKey,
  Ee as toHyper,
  Ve as toInputSource,
  p as toKey,
  Ke as toMeh,
  qe as toMouseCursorPosition,
  Le as toMouseKey,
  Te as toNone,
  se as toNotificationMessage,
  pt as toOnlyConsumerKeyCodes,
  D as toOnlyKeyCodes,
  Oe as toPaste,
  mt as toPlaySound,
  je as toPointingButton,
  ae as toRemoveNotificationMessage,
  h as toSetVar,
  Re as toSleepSystem,
  Be as toStickyModifier,
  Se as toSuperHyper,
  We as toTypeSequence,
  At as withCondition,
  Et as withMapper,
  Kt as withModifier,
  Dt as writeToProfile
};
